package HTML;

do "db.pl";

use strict;
use warnings FATAL => 'all';

our %get;
my $did_head = 0;
my $bad_param = 0;



# Split QUERY_STRING into get{var}
my $key;
foreach $_ (split ('&', $ENV{"QUERY_STRING"})) {
	($key, $_) = /(.*)=(.*)/;
	tr/+/ /;
	s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$get{$key} = $_;
}



# html_head:
# 0	title
#
sub write_head {
	my $title = defined($_[0]) ? " : $_[0]" : "";
	$did_head = 1;

	print <<EOF
Content-type: text/html; charset=utf-8

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html lang="en-us">
<head>
	<title>cod_stat v0.3.2$title</title>
	<link rel="stylesheet" title="default" media="all"
			href="style.css" />
	<link rel="alternate stylesheet" title="Google" media="all"
			href="style_google.css" />
	<link rel="alternate stylesheet" title="ugly" media="all"
			href="style_new.css" />
</head>

<body>
EOF
;
	if ($bad_param == 0) {
		my ($query, $result);
		$query = "SELECT last_game, last_players," .
				" last_map, last_map_id, " .
				" last_gt, last_gt_id" .
				" FROM quick_info";
		$result = DB::query($query);
		my ($game, $players, $map, $map_id, $gametype, $gametype_id) =
				$result->fetchrow;
		print <<EOF
<div class="header">
<table width="100%">	<!-- FIXME -->
<tr>
	<td class="server"><a href="/cod" class="no_ul">foobar64</a></td>
	<td class="search" rowspan="2">
		<form action="search.cgi" method="get">
		Go to nick/player id:
		<input name="s" size="6" />
		<input type="submit" value="Go" />
		</form>
	</td>
</tr>
<tr>
	<td class="serverinfo"><a href="game.cgi?g=$game">Last Game Hosted</a>:
	<a href="gametype.cgi?t=$gametype_id">$gametype</a>
	in <a href="map.cgi?m=$map_id">$map</a> ($players players)
	</td>
</tr>
</table>
</div>

<div class="content">

EOF
;
	}
}



# html_tail:
#
sub write_tail {
	my $delta = sprintf("%.3f", DB::write_access_log());
	print <<EOF
</div>
<div class="copyright">
Copyright &copy; 2004-2005 <a href="http://iki.fi/wnd/contact.html">Tommi
Saviranta</a> -- took $delta second(s) to generate the page
</div>
</body>
</html>
EOF
;
}



# html_bad_parameters:
#
sub bad_parameters {
	$bad_param = 1;
	write_head(1) if ($did_head == 0);
	print "<h1>LOL WTF n00b I pwn</h1>\n";
	write_tail();
	exit(0);
}



# forward
sub forward {
	my $url = $_[0];

	if ($did_head == 1) {
		print <<EOF
<div class="text">Redirect: <a href="$url">$url</a><br />
<em>Wanted to redirect you to <a href="$url">$url</a> but headers were
already sent. Click the link to get there and ask wind\@IRCNet to fix this.
</div>
EOF
;
	} else {
		print "Location: $url\n\n";
		exit(0);
	}
}
