#! /usr/bin/perl

use strict;
use warnings FATAL => 'all';

my $self = "player_search.cgi";

do "db.pl";
do "common.pl";
do "html.pl";

# parameters taken:
#	n	nick	nick to look for
#	m	match	match type: 0 = exact, 1 = icase, 2 = partial icase
#	j	seek	jump over n matches
#	s	sort	sort: 0 = nick, 1 = id

my $nick = Common::safe_string($HTML::get{"n"});
my $match = Common::safe_number($HTML::get{"m"}, 0);
my $seek = Common::safe_number($HTML::get{"j"}, 0);
my $sort = Common::safe_number($HTML::get{"s"}, 0);
my $num = 50;	# 50 nicks per page
$seek = int($seek / $num) * $num;

my $match_count;

my $nickmatch;
if ($nick =~ /./) {
	if ($match == 0) {
		$nickmatch = "WHERE name = '$nick'";
	} elsif ($match == 1) {
		$nickmatch = "WHERE name ILIKE '$nick'";
	} elsif ($match == 2) {
		$nickmatch = "WHERE name ILIKE '%${nick}%'";
	} else {
		HTML::bad_parameters();
	}
} else {
	$nickmatch = "";
}

my $sortcmd;
if ($sort == 0) {
	$sortcmd = "ORDER BY name, id";
} elsif ($sort == 1) {
	$sortcmd = "ORDER BY id, name";
} else {
	HTML::bad_parameters();
}

my ($cmd, $result, @row);
$cmd = "SELECT name, id FROM player_alias $nickmatch $sortcmd";
$result = DB::query($cmd);
$match_count = $result->ntuples;

HTML::bad_parameters() if ($seek < 0 || $seek >= $match_count);

if ($match_count == 1) {
	my ($foo, $id) = $result->fetchrow;
	HTML::forward("player.cgi?p=$id");
}

HTML::write_head();

print <<EOF
<h1>Player search</h1>
EOF
;

print_search_form();

print_showing_results();

# Seek
for (my $i = 0; $i < $seek; $i++) {
	@row = $result->fetchrow;
	$i = $seek if (! defined($row[0]));
}

print "<p>\n";
for (my $i = 0; $i < $num; $i++) {
	my ($nick, $id) = $result->fetchrow;
	if (! defined($nick)) {
		$i = $num;
		next;
	}

	printf("<a href=\"player.cgi?p=%d\">%d: %s</a><br />\n",
			$id, $id, Common::html_safe_string($nick));
}
print "</p>\n";

print_showing_results();

HTML::write_tail();



sub print_search_form {
	print <<EOF
<div id="search">
<form action="$self" method="get">
<table class="opt">
<tr class="need">
	<td class="need">Search nick</td>
	<td class="need"><input name="n" /></td>
	<td class="need"><input type="submit" value="Search" /></td>
</tr>
<tr class="need">
	<td class="need">&nbsp;</td>
	<td colspan="2" class="need">
	<input type="radio" name="m" value="2" checked="checked" />Partial<br />
	<input type="radio" name="m" value="1" />Exact case insensitive<br />
	<input type="radio" name="m" value="0" />Exact
	</td>
</tr>
<tr class="opt">
	<td class="opt">&nbsp;</td>
	<td colspan="2" class="opt">
	<input type="radio" name="s" value="0" checked="checked" />
			Sort by nick<br />
	<input type="radio" name="s" value="1" />Sort by ID
	</td>
</tr>
</table>
</form>
</div>
EOF
;
}



sub print_showing_results {
	my $this_page = $seek / $num;
	
	print "<div class=\"seek\">\n";
	printf("Results %d - %d of %d",
			$seek + 1,
			$match_count > $seek + $num ? $seek + $num : $match_count,
			$match_count);

	if ($match_count > $num) {
		print " (Result page:";
		for (my $i = 0; $i < $match_count / $num; $i++) {
			if ($i != $this_page) {
				printf(" <a href=\"%s?n=%s&amp;s=%s&amp;m=%s" .
						"&amp;j=%d\">%d</a> ",
						$self,
						$nick, $sort, $match, $i * $num,
						$i + 1);
			} else {
				printf("%d ", $i + 1);
			}
		}
		print ")";
	}
	printf("</div>\n");
}
